import arg from "arg";
import path from "path";
import fs from "fs";

require("console-info");
require("console-warn");
require("console-error");

export function cli(args) {
  const options = parseArgs(args);
  require("./deploy").run(options);
}

function parseArgs(rawArgs) {
  const args = arg(
    {
      "--gitskip": Boolean,
      "--lintskip": Boolean,
      "--config": String,
    },
    {
      argv: rawArgs.slice(2),
      permissive: true,
    }
  );
  // const conf = args["--config"] ? require(path.join(process.cwd(), args["--config"]))
  let conf;
  if (!args["--config"]) {
    try {
      fs.accessSync(path.join(process.cwd(), "eazydeploy.config.js"));
      conf = require(path.join(process.cwd(), "eazydeploy.config.js"));
      console.info(
        "using configuration file: " + process.cwd(),
        "eazydeploy.config.js"
      );
    } catch (err) {
      console.warn(
        "configuration file not provided... using default config file."
      );
      conf = require("./config");
    }
  } else {
    console.info(
      "using configuration file: " + path.join(process.cwd(), args["--config"])
    );
    conf = require(path.join(process.cwd(), args["--config"]));
  }

  return {
    gitSkip: args["--gitskip"] || false,
    lintSkip: args["--lintskip"] || false,
    config: conf,
  };
}
